#ifndef HW_MINI_SENSING_BOARD_H     
#define HW_MINI_SENSING_BOARD_H

//**************************
#ifndef LED_ON
    #define LED_ON 0x01 
#endif

#ifndef LED_OFF
    #define LED_OFF 0x00  
#endif

//**************************
#ifndef ON_STATE
    #define ON_STATE 0x01 
#endif

#ifndef OFF_STATE
    #define OFF_STATE 0x00   
#endif

//**************************
#ifndef BUTTON_PRESSED
    #define BUTTON_PRESSED 0x00
#endif

//**************************
#ifndef SET_AS_OUTPUT
    #define SET_AS_OUTPUT 0x00 
#endif

#ifndef SET_AS_INPUT
    #define SET_AS_INPUT 0x01  
#endif

//********************************************
//Output signals
//********************************************
#define LED_1  LATCbits.LATC9
#define LED_2  LATCbits.LATC8
#define LED_1_DIR  TRISCbits.TRISC9
#define LED_2_DIR  TRISCbits.TRISC8

#define BUZZER_OUT  LATCbits.LATC7
#define BUZZER_DIR  TRISCbits.TRISC7

#define AG_INT      PORTCbits.RC0
#define AG_INT_DIR  TRISCbits.TRISC0

#define OPT_INT      PORTBbits.RB1
#define OPT_INT_DIR  TRISBbits.TRISB1

#define HDC_INT     PORTBbits.RB0
#define HDC_INT_DIR TRISBbits.TRISB0


#ifdef __32MX150F128D__

    //********************************************
    // Connector J1 PINS        
    //********************************************

    #define CON_J1_PIN_4_OUT    LATAbits.LATA9  
    #define CON_J1_PIN_4_IN     PORTAbits.RA9  
    #define CON_J1_PIN_4_DIR    TRISAbits.TRISA9 
    #define P17_OUT    LATAbits.LATA9  
    #define P17_IN     PORTAbits.RA9  
    #define P17_DIR    TRISAbits.TRISA9 

    #define CON_J1_PIN_5_OUT    LATAbits.LATA7 
    #define CON_J1_PIN_5_IN     PORTAbits.RA7  
    #define CON_J1_PIN_5_DIR    TRISAbits.TRISA7
    #define P18_OUT    LATAbits.LATA7 
    #define P18_IN     PORTAbits.RA7  
    #define P18_DIR    TRISAbits.TRISA7

    #define CON_J1_PIN_6_OUT    LATBbits.LATB13 
    #define CON_J1_PIN_6_IN     PORTBbits.RB13  
    #define CON_J1_PIN_6_DIR    TRISBbits.TRISB13 
    #define P19_OUT    LATBbits.LATB13 
    #define P19_IN     PORTBbits.RB13  
    #define P19_DIR    TRISBbits.TRISB13


    #define CON_J1_PIN_7_OUT    LATBbits.LATB15
    #define CON_J1_PIN_7_IN     PORTBbits.RB15  
    #define CON_J1_PIN_7_DIR    TRISBbits.TRISB15 
    #define P20_OUT    LATBbits.LATB15
    #define P20_IN     PORTBbits.RB15  
    #define P20_DIR    TRISBbits.TRISB15 

    #define CON_J1_PIN_8_OUT    LATAbits.LATA1 
    #define CON_J1_PIN_8_IN     PORTAbits.RA1    
    #define CON_J1_PIN_8_DIR    TRISAbits.TRISA1
    #define SERVO_OUT    LATAbits.LATA1 
    #define SERVO_IN     PORTAbits.RA1    
    #define SERVO_DIR    TRISAbits.TRISA1


    //********************************************
    // Connector J2 PINS        
    //********************************************

    #define CON_J2_PIN_4_OUT    LATCbits.LATC1 
    #define CON_J2_PIN_4_IN     PORTCbits.RC1  
    #define CON_J2_PIN_4_DIR    TRISCbits.TRISC1 
    #define P8_OUT    LATCbits.LATC1 
    #define P8_IN     PORTCbits.RC1  
    #define P8_DIR    TRISCbits.TRISC1

    #define CON_J2_PIN_5_OUT    LATBbits.LATB2 
    #define CON_J2_PIN_5_IN     PORTBbits.RB2  
    #define CON_J2_PIN_5_DIR    TRISBbits.TRISB2
    #define P1_OUT    LATBbits.LATB2 
    #define P1_IN     PORTBbits.RB2  
    #define P1_DIR    TRISBbits.TRISB2

    #define CON_J2_PIN_6_OUT    LATCbits.LATC2 
    #define CON_J2_PIN_6_IN     PORTCbits.RC2  
    #define CON_J2_PIN_6_DIR    TRISCbits.TRISC2 
    #define P9_OUT    LATCbits.LATC2 
    #define P9_IN     PORTCbits.RC2  
    #define P9_DIR    TRISCbits.TRISC2 

    #define CON_J2_PIN_7_OUT    LATBbits.LATB3 
    #define CON_J2_PIN_7_IN     PORTBbits.RB3  
    #define CON_J2_PIN_7_DIR    TRISBbits.TRISB3
    #define P2_OUT    LATBbits.LATB3 
    #define P2_IN     PORTBbits.RB3  
    #define P2_DIR    TRISBbits.TRISB3

    #define CON_J2_PIN_8_OUT    LATCbits.LATC3 
    #define CON_J2_PIN_8_IN     PORTCbits.RC3  
    #define CON_J2_PIN_8_DIR    TRISCbits.TRISC3
    #define P10_OUT    LATCbits.LATC3 
    #define P10_IN     PORTCbits.RC3  
    #define P10_DIR    TRISCbits.TRISC3

    #define CON_J2_PIN_9_OUT    LATBbits.LATB4
    #define CON_J2_PIN_9_IN     PORTBbits.RB4  
    #define CON_J2_PIN_9_DIR    TRISBbits.TRISB4
    #define P3_OUT    LATBbits.LATB4
    #define P3_IN     PORTBbits.RB4  
    #define P3_DIR    TRISBbits.TRISB4 

    #define CON_J2_PIN_10_OUT   LATCbits.LATC4 
    #define CON_J2_PIN_10_IN    PORTCbits.RC4  
    #define CON_J2_PIN_10_DIR   TRISCbits.TRISC4
    #define P11_OUT   LATCbits.LATC4 
    #define P11_IN    PORTCbits.RC4  
    #define P11_DIR   TRISCbits.TRISC4

    #define CON_J2_PIN_11_OUT   LATBbits.LATB7 
    #define CON_J2_PIN_11_IN    PORTBbits.RB7  
    #define CON_J2_PIN_11_DIR   TRISBbits.TRISB7
    #define P4_OUT   LATBbits.LATB7 
    #define P4_IN    PORTBbits.RB7  
    #define P4_DIR   TRISBbits.TRISB7

    #define CON_J2_PIN_12_OUT   LATCbits.LATC5
    #define CON_J2_PIN_12_IN    PORTCbits.RC5  
    #define CON_J2_PIN_12_DIR   TRISCbits.TRISC5 
    #define P12_OUT   LATCbits.LATC5
    #define P12_IN    PORTCbits.RC5  
    #define P12_DIR   TRISCbits.TRISC5

    #define CON_J2_PIN_13_OUT   LATBbits.LATB11
    #define CON_J2_PIN_13_IN    PORTBbits.RB11  
    #define CON_J2_PIN_13_DIR   TRISBbits.TRISB11
    #define P5_OUT   LATBbits.LATB11
    #define P5_IN    PORTBbits.RB11  
    #define P5_DIR   TRISBbits.TRISB11

    #define CON_J2_PIN_14_OUT   LATCbits.LATC6
    #define CON_J2_PIN_14_IN    PORTCbits.RC6  
    #define CON_J2_PIN_14_DIR   TRISCbits.TRISC6 
    #define P13_OUT   LATCbits.LATC6
    #define P13_IN    PORTCbits.RC6  
    #define P13_DIR   TRISCbits.TRISC6

    #define CON_J2_PIN_15_OUT   LATBbits.LATB12
    #define CON_J2_PIN_15_IN    PORTBbits.RB12  
    #define CON_J2_PIN_15_DIR   TRISBbits.TRISB12 
    #define P6_OUT   LATBbits.LATB12
    #define P6_IN    PORTBbits.RB12  
    #define P6_DIR   TRISBbits.TRISB12 

    #define CON_J2_PIN_16_OUT   LATAbits.LATA4
    #define CON_J2_PIN_16_IN    PORTAbits.RA4  
    #define CON_J2_PIN_16_DIR   TRISAbits.TRISA4 
    #define P14_OUT   LATAbits.LATA4
    #define P14_IN    PORTAbits.RA4  
    #define P14_DIR   TRISAbits.TRISA4 

    #define CON_J2_PIN_17_OUT   LATBbits.LATB14
    #define CON_J2_PIN_17_IN    PORTBbits.RB14  
    #define CON_J2_PIN_17_DIR   TRISBbits.TRISB14
    #define P7_OUT   LATBbits.LATB14
    #define P7_IN    PORTBbits.RB14  
    #define P7_DIR   TRISBbits.TRISB14

    #define CON_J2_PIN_18_OUT   LATAbits.LATA8
    #define CON_J2_PIN_18_IN    PORTAbits.RA8  
    #define CON_J2_PIN_18_DIR   TRISAbits.TRISA8
    #define P15_OUT   LATAbits.LATA8
    #define P15_IN    PORTAbits.RA8  
    #define P15_DIR   TRISAbits.TRISA8

    #define CON_J2_PIN_19_OUT   LATBbits.LATB10
    #define CON_J2_PIN_19_IN    PORTBbits.RB10  
    #define CON_J2_PIN_19_DIR   TRISBbits.TRISB10 
    #define OD_OUT   LATBbits.LATB10
    #define OD_IN    PORTBbits.RB10  
    #define OD_DIR   TRISBbits.TRISB10
    #define OPEN_DRAIN_OUT   LATBbits.LATB10
    #define OPEN_DRAIN_DIR   TRISBbits.TRISB10

    #define CON_J2_PIN_20_OUT   LATAbits.LATA10
    #define CON_J2_PIN_20_IN    PORTAbits.RA10  
    #define CON_J2_PIN_20_DIR   TRISAbits.TRISA10 
    #define P16_OUT   LATAbits.LATA10
    #define P16_IN    PORTAbits.RA10  
    #define P16_DIR   TRISAbits.TRISA10
#endif

#endif

