#ifndef HW_MINI_SENSING_PLC_H    
#define HW_MINI_SENSING_PLC_H 

#ifndef LED_ON
	#define LED_ON 0x01 
#endif

#ifndef LED_OFF
	#define LED_OFF 0x00 
#endif

#ifndef ON_STATE
	#define ON_STATE 0x01 
#endif

#ifndef OFF_STATE
	#define OFF_STATE 0x00  
#endif

#ifndef INPUT_ACTIVATED
	#define INPUT_ACTIVATED 0x00 
#endif

#ifndef INPUT_DEACTIVATED
	#define INPUT_DEACTIVATED 0x01 
#endif

#ifndef SET_AS_OUTPUT
	#define SET_AS_OUTPUT 0x00  
#endif

#ifndef SET_AS_INPUT
	#define SET_AS_INPUT 0x01 
#endif

#define BUTTON_PRESSED 0x00


//********************************************
//Output signals
//********************************************
#define RELAY_1_PLC         LATCbits.LATC3
#define RELAY_1_PLC_DIR     TRISCbits.TRISC3

#define RELAY_2_PLC         LATCbits.LATC4
#define RELAY_2_PLC_DIR     TRISCbits.TRISC4



//********************************************
// Input       
//********************************************

#define INPUT_1_PLC         PORTBbits.RB12
#define INPUT_1_PLC_DIR     TRISBbits.TRISB12  


#define INPUT_2_PLC         PORTCbits.RC1
#define INPUT_2_PLC_DIR     TRISCbits.TRISC1  

//********************************************
//RS485 signals
//********************************************
#define RS485_TX_ENABLE_PLC         LATAbits.LATA7
#define RS485_TX_ENABLE_PLC_DIR     TRISAbits.TRISA7

#define RS485_RX_ENABLE_PLC         LATAbits.LATA9
#define RS485_RX_ENABLE_PLC_DIR     TRISAbits.TRISA9

#define RS485_TX_ENABLED_PLC    0x01
#define RS485_TX_DISABLED_PLC   0x00

#define RS485_RX_ENABLED_PLC    0x00
#define RS485_RX_DISABLED_PLC   0x01

#endif

