/*******************************************************************************

Author : Mauro Laurenti
Version : 1.0

Created on Date : 01/04/2023
Last update     : 01/04/2023

CopyRight 2006-2023 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author)
is intended for use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable copyright laws.
All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws (Italian or International ones), as well as to
civil liability for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgement with the Author.
Personal or educational use is allowed if the application containing the following
software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************
PURPOSES
********************************************************

This file contains all the configuration words needed for the PIC24FJ128GA204.
It can be easily adapted to other PICs according to the available configurations.

******  WARNING ******

The configurations must be changed to reflect the application needs!

*******************************************************************************/

#ifndef MCC_DEFAULT_CONFIG_H
#define MCC_DEFAULT_CONFIG_H

#ifdef COMPILER_XC
	#include <xc.h>
#endif


//******************************************************************************
// LTlib configurations
//******************************************************************************
//#define IO_LIBRARY_SUPPORTED    //MCC will overwrite it 
#define UART_LIBRARY_SUPPORTED
#define SPI_LIBRARY_SUPPORTED
#define I2C_LIBRARY_SUPPORTED
#define ADC_LIBRARY_SUPPORTED
#define FLASH_LIBRARY_SUPPORTED

//******************************************************************************
// Module Settings
//******************************************************************************

//******************************************
//                IO
//******************************************
//MCC will overwrite it   


//******************************************
//                UART
//******************************************
//MCC must set the modules pinout
#define UART1_AVAILABLE
#define UART2_AVAILABLE
#define UART3_AVAILABLE
#define UART4_AVAILABLE
#define UART5_AVAILABLE
#define UART6_AVAILABLE



//******************************************
//                SPI
//******************************************
//MCC must set the modules pinout
#define SPI1_AVAILABLE
#define SPI2_AVAILABLE
#define SPI3_AVAILABLE
#define SPI4_AVAILABLE



//******************************************
//                I2C
//******************************************
#define I2C1_AVAILABLE
#define I2C2_AVAILABLE
#define I2C3_AVAILABLE
#define I2C4_AVAILABLE


//******************************************
//                ADC
//******************************************
#define ADC_NUMBER_OF_CHANNELS 13

#define ADC_WITH_ANSEL_REG
#define ADC_PORT_CONFIGURATION_1 ANSA
#define ADC_PORT_CONFIGURATION_2 ANSB
#define ADC_PORT_CONFIGURATION_3 ANSC

//#define ADC_ENABLE_BIT AD1CON1bits.ON
//#define ADC_START_CONVERSION_BIT AD1CON1bits.SAMP
//#define ADC_STOP_CONVERSION_BIT AD1CON1bits.CLRASAM
//#define ADC_CONVERSION_DONE IFS0bits.AD1IF
//#define ADC_CHANNEL_SELECTION_REGISTER AD1CHS
//#define ADC_BUFFER ADC1BUF0
//#define ADC_SETTINGS_1 AD1CON1
//#define ADC_SETTINGS_2 AD1CON2 
//#define ADC_SETTINGS_3 AD1CON3 

////Note
////Not all the ADC channels may be implemented in the device
//#define ADC_CH0 0x00000001 
//#define ADC_CH1 0x00000002 
//#define ADC_CH2 0x00000004
//#define ADC_CH3 0x00000008
//#define ADC_CH4 0x00000010
//#define ADC_CH5 0x00000020
//#define ADC_CH6 0x00000040
//#define ADC_CH7 0x00000080
//#define ADC_CH8  0x00000100
//#define ADC_CH9  0x00000200
//#define ADC_CH10 0x00000400
//#define ADC_CH11 0x00000800
//#define ADC_CH12 0x00001000
//#define ADC_CH13 0x00002000
//#define ADC_CH14 0x00004000
//#define ADC_CH15 0x00008000


//******************************************
//                FLASH
//******************************************
//#define FLASH_ERASE_BLOCK 256  // 256 Instructions Words IW 1024 bytes        
//#define FLASH_WRITE_BLOCK 32   // 32 Instructions Words IW 128 bytes   
//
//#define DEVICE_ID_ADDRESS 0xBF80F220
//#define DEVICE_ID_WORDS 0x01
//
//#define DEVICE_REVISION_ADDRESS 0xBF80F220
//#define DEVICE_REVISION_WORDS 0x01
//
//#define FLASH_KEY_1 0xAA996655
//#define FLASH_KEY_2	0x556699AA
//
//#define DEVICE_ID 0x04A00053 


//******************************************************************************
// MCU configurations
//******************************************************************************

//MCC defines it, via the user interface


#endif
