//******************************************************************************
// In this example the DDS AD9833 generates a sine at 1.5MHz.
// The AD9833 is connected to the SPI module 1 but it can be connected also 
// to module 2 by changing the definition before the library. 
// Check the device configuration file for the peripheral pin out.
//
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_SPI.h"
#include "module_SPI.c"

#include "AD9833.h"
#include "AD9833.c"

void main(void) {
    
    uint32_t frequency = 1500000;
    
    IO_set_all_ports_as_inputs();
    
    AD9833_initialize (25);
    
    AD9833_set_function(AD9833_SIN);
    
    AD9833_set_frequency(frequency,0);
    
    while (1);    
}
