//******************************************************************************
// The software writes the Date and Time to the LCD.
// The LCD must be connected as specified in the library included above.
// The DS1337 must be connected to the I2C Module 1 of the MCU.  
// 
//
// Tested Platform: Freedom II
// Tested MCU: PIC18F4580
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "DS1337.h"
#include "DS1337.c"

#include "LCD_44780.h"
#include "LCD_44780.c"

void main(void) {
    
    IO_set_all_ports_as_inputs();
    
    LCD_initialize(20);
    RTCC_initialize(100);
    
    RTCC_set_years(0x15);
    RTCC_set_months(0x11);
    RTCC_set_days(0x22);
    
    RTCC_set_hours(0x16);
    RTCC_set_minutes(0x20);
    RTCC_set_seconds(0x22);
    
    LCD_backlight(LCD_TURN_ON_LED);
 
    while(1){
        LCD_home(); 
        LCD_write_message("Date : ");
        LCD_write_string (RTCC_get_date());                
        LCD_goto_line(2);
        LCD_write_message("Time : ");
        LCD_write_string (RTCC_get_time_seconds());
        
        delay_ms (100);
    }
}
