//******************************************************************************
// The software reads the keypad pressed button and show it to the LCD.
// The LCD must be connected as specified in the library included above.
// The keypad is connected on PORTB.
// New port can be used by defining the following before the library include:
// 
// #define KEYPAD_PORT IO_PORTx   //x is the name of the port you want.
//
// The Port you select, should have pull up resistors or you have to add it
// externally. 
//
// Refer to the schematic folder for the connection details. 
//
// Tested Platform: Freedom II
// Tested MCU: PIC18F4550
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h" 
#include "module_IO.c" 

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "GLCD_KS0108B.h"
#include "GLCD_KS0108B.c"

void main(void) {
    
    uint16_t i = 0;
    
    IO_set_all_ports_as_inputs();

    GLCD_initialize ();

    GLCD_backlight (GLCD_TURN_ON_LED);

    while (1) {

        GLCD_draw_picture (logo_1);

        GLCD_draw_window ( 0, 0, 127, 63, GLCD_FILLING_BLACK);
        GLCD_draw_window ( 2, 2, 123, 59, GLCD_FILLING_BLACK);

        delay_ms (2000);
        GLCD_clear (GLCD_FILLING_WHITE);

        GLCD_write_message (25,28,"Loading...    %");

        for (i = 0; i < 100 ; i+= 5) {
            GLCD_write_integer (90,28, i, 2, GLCD_ZERO_CLEANING_OFF);
            delay_ms (100);
        }

        GLCD_clear (GLCD_FILLING_WHITE);
        GLCD_write_message (30,28,"Hello World");
        delay_ms (300);
        GLCD_backlight (GLCD_TURN_OFF_LED);
        delay_ms (300);
        GLCD_backlight (GLCD_TURN_ON_LED);
        delay_ms (2000);

    }
    while(1);
}
