//******************************************************************************
// The software writes the "data" byte by the address "memory_address" of the 
// EEPROM pointed out by the "EEPROM_address". Afterward it makes a readback  
// and shows the readback on the LEDs connected to PORTD.
//
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "LTlib_delay.h" 
#include "LTlib_delay.c"

#include "I2C_EEPROM.h"
#include "I2C_EEPROM.c"

void main(void) {
    
    uint8_t EEPROM_address = 0xA0;
    uint16_t memory_address = 0x10;
    uint8_t write_data = 0xAA;
    uint8_t read_data = 0x00;
    
    IO_set_all_ports_as_inputs();
    
    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
    
    I2C_EEPROM_initialize (100);
    
    I2C_EEPROM_write_byte (EEPROM_address, memory_address, write_data);
  
    //delay to make sure that the data is written before is read out
    delay_ms (10);
    
    I2C_EEPROM_read_byte (EEPROM_address,memory_address, &read_data);
    
    IO_write_port(IO_PORTD, read_data);
   
    while(1);
}
