//******************************************************************************
// The software writes "Hello World" to the LCD out of a constant and a string.
// The LCD must be connected as specified in the library included above.
// 
//
// Tested Platform: Freedom II
// Tested MCU: PIC18F4550
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "LCD_44780.h"
#include "LCD_44780.c"

void main (void){

    //This is an array of chars (string)
    uint8_t sentence[] = "Hello World 2";

    IO_set_all_ports_as_inputs ();

    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);

    LCD_write_message ("Hello World 1");

    LCD_goto_line (2);

    LCD_write_string (sentence);
    
    // Waiting for nothing
    while (1) {
        
    }
}

