//******************************************************************************
// The software writes "Hello World" to the LCD.
// The LCD must be connected as specified in the library included above.
// 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.31
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "MCP2300x.h" 
#include "MCP2300x.c"

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"

void main(void) {

    IO_set_all_ports_as_inputs();
    
    LCD_initialize(20);
    
    LCD_write_message("   Hello World");
    
    LCD_backlight(LCD_TURN_ON_LED);
    
    while(1);   
}
