//******************************************************************************
// The software writes "Hello World" to the LCD.
// The LCD must be connected as specified in the library included above.
// 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.31
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "MCP2300x.h" 
#include "MCP2300x.c"

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"

void main(void) {

    IO_set_all_ports_as_inputs();

    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);
    
    //set Euro symbol
    LCD_write_data_CGRAM (0, 0b00000111);
    LCD_write_data_CGRAM (1, 0b00001000);
    LCD_write_data_CGRAM (2, 0b00011110);
    LCD_write_data_CGRAM (3, 0b00001000);
    LCD_write_data_CGRAM (4, 0b00011110);
    LCD_write_data_CGRAM (5, 0b00001000);
    LCD_write_data_CGRAM (6, 0b00000111);
    LCD_write_data_CGRAM (7, 0b00000000); //always 0
    
    //set a small house icon
    LCD_write_data_CGRAM (8, 0b00000000);
    LCD_write_data_CGRAM (9, 0b00000100);
    LCD_write_data_CGRAM (10, 0b00001110);
    LCD_write_data_CGRAM (11, 0b00011111);
    LCD_write_data_CGRAM (12, 0b00011111);
    LCD_write_data_CGRAM (13, 0b00011111);
    LCD_write_data_CGRAM (14, 0b00000000);
    LCD_write_data_CGRAM (15, 0b00000000);
        
    LCD_write_message ("Symbol : ");
    
    //write the symbol from CGRAM address 0
    LCD_write_char (0);
    
    LCD_write_char (' ');
    
    //write the symbol from CGRAM address 1
    LCD_write_char (1);
    
    while (1){      
   
    }   
}
