//******************************************************************************
// The software writes a counter and shows how to update it to reduce the
// write updates.
// 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.31
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "MCP2300x.h" 
#include "MCP2300x.c"

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"


void main (void){

    int16_t counter = 0;
    
    IO_set_all_ports_as_inputs();

    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);
    
    LCD_write_message ("Counter : ");
   
    while (1){   
        delay_ms (100);
                
        LCD_write_integer(counter, 2, LCD_ZERO_CLEANING_OFF);
        LCD_shift_cursor (LCD_LEFT, 2);
        
        counter++;
        
        if (counter > 99){
            counter = 0;
        }
            
    }    
}
