//******************************************************************************
// The software writes "Contrast Control" to the LCD out of a constant.
// The contrast is channged automatically so that the sentences are seen with 
// an incresed contrast. 
// The LCD must be connected as specified in the library included above.
//
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "module_IO.h"
#include "module_IO.c"

#define LCD_LINES 2
#define LCD_VOLTAGE 5
#include "LCD_ST7036.h"
#include "LCD_ST7036.c"

void main(void) {
    
    uint8_t contrast;
    
    IO_set_all_ports_as_inputs();
    
    LCD_initialize(20);
   
    LCD_goto_line(1);  
    LCD_write_message("Contrast Control");
            
    //Contrast change
    for (contrast = 0; contrast <= LCD_MAX_CONTRAST; contrast++ ){
        delay_ms (10);
        LCD_set_contrast (contrast);
        LCD_goto_line(2);    
        LCD_write_message("Contrast :");
        LCD_write_integer(contrast,2, LCD_ZERO_CLEANING_OFF);
    }  
    
    while(1);    
}

