//******************************************************************************
// In this example the value data is written to the MCP23008. 
// The device is connected to I2C Module 1 of the MCU.
// The MCP23008 address is 0 (A0=A1=A2=GND).
// The MCP23008 is connected to I2C module 2 but module 1 can be selected as well
// by changing the definition before the library. 
// The reset Line must be connected to Vcc to enable the device
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "MCP2300x.h"
#include "MCP2300x.c"

void main(void) {
    
    uint8_t device_address = 0x00;
    uint8_t data = 0x55;
    
    IO_set_all_ports_as_inputs();
    
    MCP2300x_initialize(200);
    
    MCP2300x_set_port_direction(device_address,0x00);
    
    MCP2300x_set_port_value(device_address, data);
    
    while(1);
}
