//******************************************************************************
// In this example one LED is turned on as RED and is rotating within the string. 
// The string is connected to PORTD pin RD0 (Group 1)
// The string is made of 12 LEDs.
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "WS2812B.h"
#include "WS2812B.c"

void main (void){
    
    uint8_t counter = 0;
    uint8_t subcounter = 0;
    
    WS2812_initialize();
    WS2812_turn_off_group(LED_GROUP_1);
    
    while (1){
    
        for (counter = 0; counter < group_size[0] ; counter++){
            
            WS2812_reset_LED(LED_GROUP_1);
            
            for (subcounter = 0; subcounter < counter; subcounter++){
                WS2812_turn_on_LED(LED_GROUP_1, 0,0,0);   
            }
            
            WS2812_turn_on_LED(LED_GROUP_1, 255,0,0);  
            delay_ms (100); 
            WS2812_turn_off_group(LED_GROUP_1);
        }      
    }    
}
