//******************************************************************************
// The software reads the voltage out of the trimmer connected to the ADC channel 
// CH1. The value is shown to the LCD that must be connected as specified in
// the library included above. 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "module_ADC.h"
#include "module_ADC.c"

#include "MCP2300x.h"
#include "MCP2300x.c"

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"

void main (void){
    
    IO_set_all_ports_as_inputs();
    
    LCD_initialize(20);
    
    while(1){
        LCD_home();
        LCD_write_message("Value : ");
        LCD_write_integer (ADC_read_channel(ADC_CH1), 4, LCD_ZERO_CLEANING_OFF);     
    }
}