//******************************************************************************
// The software writes to the EEPROM location "address" the value "data".
// Afterward it reads the address back and write the content to PORTD.
// PORTD should have LEDs connected to it. 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_EEPROM.h"
#include "module_EEPROM.c"

#include "module_IO.h"
#include "module_IO.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

void main(void) {
    
    uint16_t address = 0x1F;
    uint8_t data = 0x53;
    uint8_t read_back = 0x00;
    
    IO_set_all_ports_as_inputs();
    
    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
    
    EEPROM_write_byte(address, data);
    
    //wait for the data to be written, before read it back
    delay_ms (10);
    
    read_back = EEPROM_read_byte (address);
    
    IO_write_port(IO_PORTD, read_back);
     
    while(1);
}
