//******************************************************************************
// The software reads from the flash memory the device ID and the die version.
// The values are written to the LCD connected as specified by the LCD library 
// included above. 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "LTlib_utilities.h"
#include "LTlib_utilities.c"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "module_FLASH.h"
#include "module_FLASH.c"

#include "MCP2300x.h"
#include "MCP2300x.c"

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"

void main(void) {
    
    IO_set_all_ports_as_inputs();
    
    LCD_initialize(20);
    
    LCD_backlight(LCD_TURN_ON_LED);
    
    LCD_write_message("Device ID: ");
    LCD_write_integer(FLASH_read_device_ID(), 4, LCD_ZERO_CLEANING_ON);
    
    LCD_goto_line(2);
    
    LCD_write_message("Device Ver. : ");
    LCD_write_integer(FLASH_read_device_revision(), 2, LCD_ZERO_CLEANING_ON);
    
    while(1);
}
