//******************************************************************************
// The software reads PORTB where you have 4 buttons on RB4-RB7 (BT1-BT4).
// The button that gets pressed is shown on PORTD where you need to connects
// 4 LEDs from RD0 to RD3.
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

void main(void) {
    
    uint8_t data;

    IO_set_port_direction(IO_PORTB, IO_BIT4_IN + IO_BIT5_IN + IO_BIT6_IN + IO_BIT7_IN);
    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
    
    IO_enable_pull_up_resistors (IO_PORTB, IO_BIT4 + IO_BIT5 + IO_BIT6 + IO_BIT7);
       
    while(1){
        //It shifts 4 positions to get BT1 associated with LED1 on PORD bit 0
        data = IO_read_port(IO_PORTB);
        IO_write_port(IO_PORTD,(~data >> 4) & 0x0F);
    }
}
