//******************************************************************************
// The software reads PORTB where you have 4 buttons on RB4-RB7 (BT1-BT4).
// If the button on RB4 is pressed all the LEDs on PORTD are turned ON.
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#define BUTTON_PRESSED 0x00

void main(void) {
    
    IO_set_all_ports_as_inputs();
    
    IO_enable_pull_up_resistors (IO_PORTB, IO_BIT4 + IO_BIT5 + IO_BIT6 + IO_BIT7);
     
    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
 
    while(1){
        
        if (IO_read_port_bit(IO_PORTB, IO_BIT4) == BUTTON_PRESSED) {
            IO_write_port(IO_PORTD, 0xFF);
        } else {
            IO_write_port(IO_PORTD, 0x00);
        }        
    }
}
