//******************************************************************************
// The software is an SPI Slave. It receives the data from the Master.
// A second MCU must be programmed with the Master firmware to transmit the data. 
// The SPI module is 1 but it can be selected in the Firmware and it could be 
// different from the Master.
//
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_SPI.h"
#include "module_SPI.c"

//*************************************
//           SPI Slave
//*************************************

void main(void) {

    IO_set_all_ports_as_inputs();
    
    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
    
    SPI1_mode(SPI_MODE_1);
    SPI1_open(SPI_SLAVE_DEVICE);
   
    while (1) {
       IO_write_port(IO_PORTD, SPI1_read_byte()); 
    }
}

