//******************************************************************************
// The software sends any data received by the UART back. 
// The echo function is done by adding 1 to the received character. 
// 
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_UART.h"
#include "module_UART.c"

void main(void) {
    
    uint8_t data;
    
    IO_set_all_ports_as_inputs();
      
    UART1_open(UART_BAUDRATE_19200);
   
    while(1){
        
        if (UART1_data_ready ()) {
            
           data = UART1_read_byte(); 
           
           //Echo +1 just to be sure that the echo is coming from the MCU.
           //If you press "a" the echo will be "b".
           //Remove +1 to get a true echo.
           UART1_write_byte(data + 1);
        }        
    }
}
