//******************************************************************************
// The example lets all the LEDs on PORTB blink with 2s period.
//
// Tested Platform: Freedom III
// Tested MCU: PIC18F46K22
// Tested Compiler: XC8 2.05
//******************************************************************************

#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

void main(void) {

    IO_set_all_ports_as_inputs();

    IO_set_port_direction(IO_PORTD, IO_ALL_PORT_OUTPUT);
    
    delay_set_quartz (20);

    //The LEDs on PORTD will blink at 0.5Hz 
    while (1) {
        
        IO_write_port(IO_PORTD, 0xFF);
        delay_s (1);
        IO_write_port(IO_PORTD, 0x00);
        delay_s (1);
    }
}
