/*******************************************************************************

Author : Mauro Laurenti
Version : 1.1
 
Created on Date : 08/12/2018
Last update     : 28/07/2019

CopyRight 2006-2019 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgement with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.


*******************************************************************************/
#ifdef COMPILER_XC
    #include <xc.h>
#endif

#include "ADXL335.h"


//************************************************************
//     ADXL335_read_acceleration function implementation
//************************************************************
int16_t ADXL335_read_acceleration (uint8_t acc_component){
   
    uint16_t component_value = 0x00;
    int16_t final_value = 0x00;
    
    component_value = ADC_read_channel (acc_component);
   
    if (component_value >= ADXL335_0g) {        
       final_value = (int16_t)(component_value - ADXL335_0g);
    } else {
       final_value = ((int16_t)(ADXL335_0g - component_value)) * (-1);
    }
   
    return (final_value);
}

