/*******************************************************************************
 
Autore : Mauro Laurenti
Versione : 1.1
 
Created on Date : 16/03/2016
Last update     : 31/01/2019

CopyRight 2006-2019 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgement with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 
*******************************************************************************/

#ifdef COMPILER_XC
    #include <xc.h>
#endif

#include "module_ADC.h"


//************************************************************
//         ADC_open function implementation
//************************************************************
void ADC_open (uint32_t ADC_enable_channel){
       
    #ifdef ADC_MODULE_TYPE_1 
        ADC_SETTINGS_1 = 0xC0;
        if (ADC_enable_channel & ADC_CH0) ADC_SETTINGS_1 = 0x0E; 
        if (ADC_enable_channel & ADC_CH1) ADC_SETTINGS_1 = 0x0D; 
        if (ADC_enable_channel & ADC_CH2) ADC_SETTINGS_1 = 0x0C; 
        if (ADC_enable_channel & ADC_CH3) ADC_SETTINGS_1 = 0x0B; 
        if (ADC_enable_channel & ADC_CH4) ADC_SETTINGS_1 = 0x0A; 
        if (ADC_enable_channel & ADC_CH5) ADC_SETTINGS_1 = 0x09; 
        if (ADC_enable_channel & ADC_CH6) ADC_SETTINGS_1 = 0x08; 
        if (ADC_enable_channel & ADC_CH7) ADC_SETTINGS_1 = 0x07; 

        if (ADC_enable_channel & ADC_CH8) ADC_SETTINGS_1 = 0x06; 
        if (ADC_enable_channel & ADC_CH9) ADC_SETTINGS_1 = 0x05; 
        if (ADC_enable_channel & ADC_CH10) ADC_SETTINGS_1 = 0x04; 
        if (ADC_enable_channel & ADC_CH11) ADC_SETTINGS_1 = 0x03; 
        if (ADC_enable_channel & ADC_CH12) ADC_SETTINGS_1 = 0x02; 
    #endif
    
        
    #ifdef ADC_MODULE_TYPE_2 
        ANSELAbits.ANSA0 = (ADC_enable_channel & ADC_CH0) && 0x01; 
        ANSELAbits.ANSA1 = (ADC_enable_channel & ADC_CH1) && 0x01; 
        ANSELAbits.ANSA2 = (ADC_enable_channel & ADC_CH2) && 0x01; 
        ANSELAbits.ANSA3 = (ADC_enable_channel & ADC_CH3) && 0x01; 
        ANSELAbits.ANSA5 = (ADC_enable_channel & ADC_CH4) && 0x01; 
        ANSELEbits.ANSE0 = (ADC_enable_channel & ADC_CH5) && 0x01; 
        ANSELEbits.ANSE1 = (ADC_enable_channel & ADC_CH6) && 0x01; 
        ANSELEbits.ANSE2 = (ADC_enable_channel & ADC_CH7) && 0x01; 

        ANSELBbits.ANSB2 = (ADC_enable_channel & ADC_CH8) && 0x01; 
        ANSELBbits.ANSB3 = (ADC_enable_channel & ADC_CH9) && 0x01; 
        ANSELBbits.ANSB1 = (ADC_enable_channel & ADC_CH10) && 0x01; 
        ANSELBbits.ANSB4 = (ADC_enable_channel & ADC_CH11) && 0x01; 
        ANSELBbits.ANSB0 = (ADC_enable_channel & ADC_CH12) && 0x01; 
        ANSELBbits.ANSB5 = (ADC_enable_channel & ADC_CH13) && 0x01; 
        ANSELCbits.ANSC2 = (ADC_enable_channel & ADC_CH14) && 0x01; 
        ANSELCbits.ANSC3 = (ADC_enable_channel & ADC_CH15) && 0x01;
       
        ANSELCbits.ANSC4 = (ADC_enable_channel & ADC_CH16) && 0x01; 
        ANSELCbits.ANSC5 = (ADC_enable_channel & ADC_CH17) && 0x01; 
        ANSELCbits.ANSC6 = (ADC_enable_channel & ADC_CH18) && 0x01; 
        ANSELCbits.ANSC7 = (ADC_enable_channel & ADC_CH19) && 0x01; 
        ANSELDbits.ANSD0 = (ADC_enable_channel & ADC_CH20) && 0x01; 
        ANSELDbits.ANSD1 = (ADC_enable_channel & ADC_CH21) && 0x01; 
        ANSELDbits.ANSD2 = (ADC_enable_channel & ADC_CH22) && 0x01; 
        ANSELDbits.ANSD3 = (ADC_enable_channel & ADC_CH23) && 0x01; 
        
        ANSELDbits.ANSD4 = (ADC_enable_channel & ADC_CH24) && 0x01; 
        ANSELDbits.ANSD5 = (ADC_enable_channel & ADC_CH25) && 0x01; 
        ANSELDbits.ANSD6 = (ADC_enable_channel & ADC_CH26) && 0x01; 
        ANSELDbits.ANSD7 = (ADC_enable_channel & ADC_CH27) && 0x01;     
    #endif
    
    #ifdef ADC_MODULE_TYPE_4 
        ADC_SETTINGS_1 = 0xC0;
    #endif    
        
        
    #if defined (ADC_MODULE_TYPE_1) || defined (ADC_MODULE_TYPE_2) || defined (ADC_MODULE_TYPE_3)
        ADC_set_reference (ADC_VREF_P_AVDD, ADC_VREF_N_AVSS);
        ADC_set_acquisition_time(ADC_ACQUISITION_TIME_20_TAD);
    #endif

    ADC_set_justification (ADC_JUSTIFICATION_RIGHT);
    ADC_set_clock(ADC_CLOCK_FOSC_64);
    
    ADC_ENABLE_BIT |= 0x01;
}


//************************************************************
//         ADC_close function implementation
//************************************************************
void ADC_close (void){
    ADC_ENABLE_BIT = 0x00;  
    
    #ifdef ADC_MODULE_TYPE_1 
        ADC_SETTINGS_1 &= 0xCF;    
    #endif
    
    #ifdef ADC_MODULE_TYPE_2 
        ANSELA = 0; 
        ANSELB = 0; 
        ANSELC = 0; 
        ANSELD = 0; 
        ANSELE = 0;    
    #endif

    #ifdef ADC_MODULE_TYPE_3 
        ANSEL = 0; 
        ANSELH = 0; 
    #endif    

    #ifdef ADC_MODULE_TYPE_4 
        ADC_SETTINGS_1 = 0x06;    
    #endif 
    
}


//************************************************************
//         ADC_select_channel function implementation
//************************************************************
void ADC_select_channel (uint32_t ADC_channel){
    
    #if defined (ADC_MODULE_TYPE_1) || defined (ADC_MODULE_TYPE_3)
        //Clear the Channel bits
        ADC_CHANNEL_SELECTION_REGISTER &= 0xC3;
        ADC_CHANNEL_SELECTION_REGISTER |= ADC_channel_converter (ADC_channel)<< 2;
    #endif  
        
    #ifdef ADC_MODULE_TYPE_2
        //Clear the Channel bits
        ADC_CHANNEL_SELECTION_REGISTER &= 0x83;
        ADC_CHANNEL_SELECTION_REGISTER |= ADC_channel_converter (ADC_channel)<< 2;
    #endif     

    #ifdef ADC_MODULE_TYPE_4
        //Clear the Channel bits
        ADC_CHANNEL_SELECTION_REGISTER &= 0xC7;
        ADC_CHANNEL_SELECTION_REGISTER |= ADC_channel_converter (ADC_channel)<< 3;
    #endif          
}


//************************************************************
//         ADC_start_conversion function implementation
//************************************************************
void ADC_start_conversion (void){
    ADC_START_CONVERSION_BIT = 0x01;
}


//************************************************************
//         ADC_abort_conversion function implementation
//************************************************************
void ADC_abort_conversion (void){
    ADC_START_CONVERSION_BIT = 0x00;
}


//************************************************************
//         ADC_abort_conversion function implementation
//************************************************************
uint16_t ADC_read_value (void){
    uint16_t ADC_value = 0;
    
    ADC_value = (((uint16_t)ADC_BUFFER_HIGH) << 8) | ADC_BUFFER_LOW;
 
    return (ADC_value);
}


//************************************************************
//         ADC_is_converting function implementation
//************************************************************
uint8_t ADC_is_converting (){
    return (ADC_START_CONVERSION_BIT);
}


//************************************************************
//         ADC_set_acquisition_time function implementation
//************************************************************
void ADC_set_acquisition_time (register_size acq_time){
    
    #if defined (ADC_MODULE_TYPE_1) || defined (ADC_MODULE_TYPE_2) || defined (ADC_MODULE_TYPE_3)
        ADC_SETTINGS_2 &= 0xC7;
        ADC_SETTINGS_2 |= acq_time;
    #endif
}


//************************************************************
//         ADC_set_clock function implementation
//************************************************************
void ADC_set_clock (register_size ADC_clock){
   
    #if defined (ADC_MODULE_TYPE_1) || defined (ADC_MODULE_TYPE_2) || defined (ADC_MODULE_TYPE_3)
        ADC_SETTINGS_2 &= 0xF8;
        ADC_SETTINGS_2 |= ADC_clock;
    #endif

    #ifdef ADC_MODULE_TYPE_4 
        ADC_SETTINGS_0 &= 0x9F;
        ADC_SETTINGS_0 |= ADC_clock;
    #endif    
}


//************************************************************
//         ADC_set_justification function implementation
//************************************************************
void ADC_set_justification (uint8_t ADC_justification){
    ADC_JUSTIFICATION = ADC_justification;
}


//************************************************************
//         ADC_set_reference function implementation
//************************************************************
void ADC_set_reference (register_size ADC_reference_V_P, register_size ADC_reference_V_N){
    
    #ifdef ADC_MODULE_TYPE_1 
        ADC_SETTINGS_1 &= 0xCF;
        ADC_SETTINGS_1 |= ADC_reference_V_P + ADC_reference_V_N;
    #endif

    #if defined (ADC_MODULE_TYPE_2) || defined (ADC_MODULE_TYPE_3)
        ADC_SETTINGS_1 &= 0x80;
        ADC_SETTINGS_1 |= ADC_reference_V_P + ADC_reference_V_N;
    #endif    
}


//************************************************************
//         ADC_read_channel function implementation
//************************************************************
uint16_t ADC_read_channel (uint32_t ADC_channel){
    
    uint16_t ADC_value = 0;
    
    ADC_open(ADC_channel);
    ADC_select_channel (ADC_channel);

    ADC_start_conversion();

    while(ADC_is_converting());

    ADC_value = ADC_read_value();
    
    ADC_close();
    
    return(ADC_value);    
}


//************************************************************
//         ADC_channel_converter function implementation
//************************************************************
uint8_t ADC_channel_converter (uint32_t channel_mask){

    uint32_t filter = 0x00000001;
    uint8_t counter = 0;
    uint8_t adc_channel = 0;

    for (counter=0; counter < ADC_NUMBER_OF_CHANNELS; counter++){
        if(channel_mask & filter){
            adc_channel = counter;
        }
        filter = filter << 1;
    }
    return (adc_channel);
}
